/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.6-dev */

#ifndef PB_PROTOBUF_AUTHENTICATION_PB_H_INCLUDED
#define PB_PROTOBUF_AUTHENTICATION_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
typedef enum _CpuFamily { 
    CpuFamily_CPU_UNKNOWN = 0, 
    CpuFamily_CPU_X86 = 1, 
    CpuFamily_CPU_X86_64 = 2, 
    CpuFamily_CPU_PPC = 3, 
    CpuFamily_CPU_PPC_64 = 4, 
    CpuFamily_CPU_ARM = 5, 
    CpuFamily_CPU_IA64 = 6, 
    CpuFamily_CPU_SH = 7, 
    CpuFamily_CPU_MIPS = 8, 
    CpuFamily_CPU_BLACKFIN = 9 
} CpuFamily;

typedef enum _Os { 
    Os_OS_UNKNOWN = 0, 
    Os_OS_WINDOWS = 1, 
    Os_OS_OSX = 2, 
    Os_OS_IPHONE = 3, 
    Os_OS_S60 = 4, 
    Os_OS_LINUX = 5, 
    Os_OS_WINDOWS_CE = 6, 
    Os_OS_ANDROID = 7, 
    Os_OS_PALM = 8, 
    Os_OS_FREEBSD = 9, 
    Os_OS_BLACKBERRY = 10, 
    Os_OS_SONOS = 11, 
    Os_OS_LOGITECH = 12, 
    Os_OS_WP7 = 13, 
    Os_OS_ONKYO = 14, 
    Os_OS_PHILIPS = 15, 
    Os_OS_WD = 16, 
    Os_OS_VOLVO = 17, 
    Os_OS_TIVO = 18, 
    Os_OS_AWOX = 19, 
    Os_OS_MEEGO = 20, 
    Os_OS_QNXNTO = 21, 
    Os_OS_BCO = 22 
} Os;

typedef enum _AuthenticationType { 
    AuthenticationType_AUTHENTICATION_USER_PASS = 0, 
    AuthenticationType_AUTHENTICATION_STORED_SPOTIFY_CREDENTIALS = 1, 
    AuthenticationType_AUTHENTICATION_STORED_FACEBOOK_CREDENTIALS = 2, 
    AuthenticationType_AUTHENTICATION_SPOTIFY_TOKEN = 3, 
    AuthenticationType_AUTHENTICATION_FACEBOOK_TOKEN = 4 
} AuthenticationType;

/* Struct definitions */
typedef PB_BYTES_ARRAY_T(512) LoginCredentials_auth_data_t;
typedef struct _LoginCredentials { 
    char username[30]; 
    AuthenticationType typ; 
    LoginCredentials_auth_data_t auth_data; 
} LoginCredentials;

typedef struct _SystemInfo { 
    CpuFamily cpu_family; 
    Os os; 
    char system_information_string[16]; 
    char device_id[50]; 
} SystemInfo;

typedef struct _ClientResponseEncrypted { 
    LoginCredentials login_credentials; 
    SystemInfo system_info; 
    bool has_version_string;
    char version_string[32]; 
} ClientResponseEncrypted;


/* Helper constants for enums */
#define _CpuFamily_MIN CpuFamily_CPU_UNKNOWN
#define _CpuFamily_MAX CpuFamily_CPU_BLACKFIN
#define _CpuFamily_ARRAYSIZE ((CpuFamily)(CpuFamily_CPU_BLACKFIN+1))

#define _Os_MIN Os_OS_UNKNOWN
#define _Os_MAX Os_OS_BCO
#define _Os_ARRAYSIZE ((Os)(Os_OS_BCO+1))

#define _AuthenticationType_MIN AuthenticationType_AUTHENTICATION_USER_PASS
#define _AuthenticationType_MAX AuthenticationType_AUTHENTICATION_FACEBOOK_TOKEN
#define _AuthenticationType_ARRAYSIZE ((AuthenticationType)(AuthenticationType_AUTHENTICATION_FACEBOOK_TOKEN+1))


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define SystemInfo_init_default                  {_CpuFamily_MIN, _Os_MIN, "", ""}
#define LoginCredentials_init_default            {"", _AuthenticationType_MIN, {0, {0}}}
#define ClientResponseEncrypted_init_default     {LoginCredentials_init_default, SystemInfo_init_default, false, ""}
#define SystemInfo_init_zero                     {_CpuFamily_MIN, _Os_MIN, "", ""}
#define LoginCredentials_init_zero               {"", _AuthenticationType_MIN, {0, {0}}}
#define ClientResponseEncrypted_init_zero        {LoginCredentials_init_zero, SystemInfo_init_zero, false, ""}

/* Field tags (for use in manual encoding/decoding) */
#define LoginCredentials_username_tag            10
#define LoginCredentials_typ_tag                 20
#define LoginCredentials_auth_data_tag           30
#define SystemInfo_cpu_family_tag                10
#define SystemInfo_os_tag                        60
#define SystemInfo_system_information_string_tag 90
#define SystemInfo_device_id_tag                 100
#define ClientResponseEncrypted_login_credentials_tag 10
#define ClientResponseEncrypted_system_info_tag  50
#define ClientResponseEncrypted_version_string_tag 70

/* Struct field encoding specification for nanopb */
#define SystemInfo_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UENUM,    cpu_family,       10) \
X(a, STATIC,   REQUIRED, UENUM,    os,               60) \
X(a, STATIC,   REQUIRED, STRING,   system_information_string,  90) \
X(a, STATIC,   REQUIRED, STRING,   device_id,       100)
#define SystemInfo_CALLBACK NULL
#define SystemInfo_DEFAULT NULL

#define LoginCredentials_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, STRING,   username,         10) \
X(a, STATIC,   REQUIRED, UENUM,    typ,              20) \
X(a, STATIC,   REQUIRED, BYTES,    auth_data,        30)
#define LoginCredentials_CALLBACK NULL
#define LoginCredentials_DEFAULT NULL

#define ClientResponseEncrypted_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, MESSAGE,  login_credentials,  10) \
X(a, STATIC,   REQUIRED, MESSAGE,  system_info,      50) \
X(a, STATIC,   OPTIONAL, STRING,   version_string,   70)
#define ClientResponseEncrypted_CALLBACK NULL
#define ClientResponseEncrypted_DEFAULT NULL
#define ClientResponseEncrypted_login_credentials_MSGTYPE LoginCredentials
#define ClientResponseEncrypted_system_info_MSGTYPE SystemInfo

extern const pb_msgdesc_t SystemInfo_msg;
extern const pb_msgdesc_t LoginCredentials_msg;
extern const pb_msgdesc_t ClientResponseEncrypted_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define SystemInfo_fields &SystemInfo_msg
#define LoginCredentials_fields &LoginCredentials_msg
#define ClientResponseEncrypted_fields &ClientResponseEncrypted_msg

/* Maximum encoded size of messages (where known) */
#define ClientResponseEncrypted_size             665
#define LoginCredentials_size                    550
#define SystemInfo_size                          75

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
